<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.1/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  
  <!-- Import DataTable Library -->
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  
</head>
<body>
<div class="container">
  <div class="text-center mt-2 mb-2">
    <h2>F120 - Quản trị Order</h2>
  </div>
  <div class="jumbotron container">
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="voucherCodeInput">Loại Pizza</label>
      </div>
      <div class="col-sm-6">
        <select id="gPizzaTypeSelect" class="form-control">

        </select>
      </div>
      <div class="col-sm-3">
        <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
      </div>
    </div>
</div>

<div class="container">
  <table class="table table-bordered table-striped table-hover" id="order-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã order</th>
        <th>Loại Pizza</th>
        <th>Tên khách hàng</th>
        <th>Ngày đặt hàng</th>
        <th>Trạng thái</th>
        <th>Action</th>
      </tr>
    </thead>
  </table>
</div>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // mảng orders
  var gOrderObjects = [
      {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
      },
      {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
      },
      {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
      },
      {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
      },
      {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
      }
    ];
  
  // mảng pizza Type
  var gPizzaType = [
    {
      typeId: 10,
      typeName: "Hải Sản"
    },
    {
      typeId: 15,
      typeName: "Bò bít tết"
    },
    {
      typeId: 20,
      typeName: "Thịt gà"
    }
  ];

  var gSTT = 1;

  const gTABLE_ROW = ["id", "orderCode", "gPizzaTypeId", "customerName", "date", "status", "action"];
  const gSTT_COL = 0;
  const gORDER_CODE_COL = 1;
  const gPIZZA_TYPE_COL = 2;
  const gNAME_COL = 3;
  const gDATE_COL = 4;
  const gSTATUS_COL = 5;
  const gACTION_COL = 6;

  var gTable = $("#order-table").DataTable({
    columns: [
      {data: gTABLE_ROW[gSTT_COL]},
      {data: gTABLE_ROW[gORDER_CODE_COL]},
      {data: gTABLE_ROW[gPIZZA_TYPE_COL]},
      {data: gTABLE_ROW[gNAME_COL]},
      {data: gTABLE_ROW[gDATE_COL]},
      {data: gTABLE_ROW[gSTATUS_COL]},
      {data: gTABLE_ROW[gACTION_COL]},
    ],
    columnDefs: [
      {
        targets: gSTT_COL,
        render: function() {
          return gSTT ++;
        }
      },
      {
        targets: gPIZZA_TYPE_COL,
        render: getPizzaNameByTypeId,
      },
      {
        targets: gACTION_COL,
        defaultContent: `
          <i class="fa-solid fa-lg fa-pen-to-square text-success edit-order" title="Edit" style=" cursor: pointer"></i>
          <i class="fa-solid fa-lg fa-trash-can text-danger ml-2 delete-order"title="Delete" style=" cursor: pointer"></i>
        `
      }
    ]
  })
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function() {
    // gán sự kiện load trang
    onPageLoading();
    // gán sự kiện click button Lọc dữ liệu
    $(document).on("click", "#btn-filter-order", onBtnFilterClick);
  })
  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  // function xử lý sự kiện load trang/F5
  function onPageLoading() {
    loadPizzaDataToSelect();
    getDataAndDisplayTable(gOrderObjects);
  }

  // function xử lý sự kiện click button Lọc dữ liệu
  function onBtnFilterClick() {
    let vPizzaId = {
      typeId: "",
    }
    // B1: Thu thập dữ liệu
    getPizzaType(vPizzaId);
    // B2: Kiểm tra dữ liệu
    // B3: Xử lý hiển thị
    let vFilterData = getFilterDataPizza(vPizzaId);
    getDataAndDisplayTable(vFilterData);
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm trả về pizzaTypeName dựa vào typeId
  function getPizzaNameByTypeId(paramTypeId) {
    "use strict";
    var vPizzaTypeName = "";
    var vIndex = 0;
    var vIsTypeFound = false;
    while(!vIsTypeFound && vIndex < gPizzaType.length) {
      if(gPizzaType[vIndex].typeId === paramTypeId) {
        vIsTypeFound = true;
        vPizzaTypeName = gPizzaType[vIndex].typeName;
      }
      else {
        vIndex ++;
      }
    }
    return vPizzaTypeName;
  }

  // function load dữ liệu Loại pizza vào Select
  function loadPizzaDataToSelect() {
    for (let bPizza of gPizzaType) {
      $("#gPizzaTypeSelect").append(
        $("<option>").val(bPizza.typeId).text(bPizza.typeName)
      );
    }
  }

  // function lấy dữ liệu và hiển thị order Data Table
  function getDataAndDisplayTable(paramOrderData) {
    gSTT = 1;
    gTable.clear();
    gTable.rows.add(paramOrderData);
    gTable.draw();
  }

  // function thu thập dữ liệu select pizza
  function getPizzaType(paramPizzaId) {
    paramPizzaId.typeId = $("#gPizzaTypeSelect").val();
  }

  // function xử lý hiển thị filter pizza
  function getFilterDataPizza(paramPizzaId) {
    let vFilterData = [];
    for (let bPizza of gOrderObjects) {
      if (bPizza.gPizzaTypeId == paramPizzaId.typeId) {
        vFilterData.push(bPizza);
      }
    }
    return vFilterData;
  }

</script>
</body>
</html>